
//#define IML_NO_SAFETY

// INCLUDE THE APPLICATION INDEPENDENT HELPER ROUTINES
// NOT DOING THIS FOR MAC YET . . .
//#include "imlapp.h"


#include "iml_file.h"
#include "iml_rofn.h"

// THESE REPRESENT TWO LEVELS OF SAFTEY FOR INDEXING.
// TURN AT LEAST ONE ON TO PREVENT BAD INDEX VALUES.
// THIS MAY SLOW YOUR PROGRAM.  NOTE THAT CORRECTIONS ARE
// SILENT.  BUT IF YOU ARE GETTING CRASHES WITH THIS OFF,
// THEN TURN THEM ON TO FIND OUT IF IT IS BECAUSE YOU ARE
// INDEXING IMAGES INCORRECTLY.
#include "mvl_macv.h"

//======================================================================
// THIS ENCAPSULATES AND ISOLATES A FEW THINGS. :-)
//======================================================================
class random_screen_position {
		uniform_rv UniformX;
		uniform_rv UniformY;
//		IML_FLOAT MaxXValue;
//		IML_FLOAT MaxYValue;
		point_2d Temp;
		
	public:
	
		random_screen_position(IML_LINT Seed1, IML_LINT Seed2) {
	//		UniformX.use_FSULTRA();
	//		UniformY.use_FSULTRA();
			
			UniformX.set_min_max(0.0, 2.0 - 1e-6);
			UniformX.seed( Seed1 );
			UniformY.set_min_max(0.0, 2.0 - 1e-6);
			UniformY.seed( Seed2 );
			};
		
		void set_X_min_max(IML_LINT MinX, IML_LINT MaxX) 
			{ UniformX.set_min_max(MinX,MaxX+0.9999); };
		
		void set_Y_min_max(IML_LINT MinY, IML_LINT MaxY) 
			{ UniformY.set_min_max(MinY,MaxY+0.9999); };
		
		operator const point_2d IML_REF const () {
	
			Temp.X = UniformX.sample();
			Temp.Y = UniformY.sample();
			return(Temp);
			}; // end operator=
		
}; // end class

void simple_randots(mvl_video_manager & MacVideo,
		IML_LINT  XSize, IML_LINT YSize, IML_LINT SeqLength, 
		point_2d IML_REF Delta, IML_USINT LifeTime,
		point_2d IML_REF Position );
		
void mckee_welch_randots(mvl_video_manager & MacVideo,
		IML_LINT  XSize, IML_LINT YSize, IML_LINT SeqLength, 
		IML_USINT DotCount, IML_FLOAT SpatialSNR,
		point_2d IML_REF Delta, IML_USINT LifeTime,
		point_2d IML_REF Position, IML_LINT GroupRefresh=FALSE);

void M_and_W_spacetime_randots_fourier(mvl_video_manager & MacVideo,
		IML_LINT  XSize, IML_LINT YSize, IML_LINT SeqLength, 
		IML_USINT DotCount, IML_FLOAT SpatialSNR,
		point_2d IML_REF Delta, IML_USINT LifeTime,
		point_2d IML_REF Position, IML_LINT GroupRefresh, long Amplitude);
		
char get_key_stroke(void);


char get_key_stroke(void) {
static	EventRecord AnyEvent;
	FlushEvents(everyEvent,0);
	while( !GetNextEvent( keyDownMask | autoKeyMask, &AnyEvent ) ){};
	return(AnyEvent.message&0x000000FF);
}

//============================================================================
//
//============================================================================
int main () {

/***********
matsumoto_MT19937B UMT;
UMT.seed(4357);
fprintf(stderr,"runningh . . .\n");fflush(stderr);
//double First = UMT.sample();
for(long K=0; K<1000; K++){
//	if(First == UMT.sample() ) { fprintf(stderr,"%d, %d %f\n", K/8, K%8, UMT.sample()); fflush(stderr); break; }
	
	fprintf(stderr,"%f ",UMT.sample());
	if( !(K%8) ) fprintf(stderr,"\n");fflush(stderr);
	
	}
fprintf(stderr,"done . . \n");fflush(stderr);
return(0);
*************/


//======== EXAMPLE  CODE FOR CREATING AND INITIALIZING mvl_video_manager

	
try {  
	// ALL THE CODE HERE IS SET FOR CATCHING EXCEPTIONS 
	// WITH AN EMPTY catch() AT THE BOTTOM.  

	// MAKE A VIDEO MANAGER OBJECT AND INITIALIZE IT
	// I'LL PROVIDE AND USE MORE ERROR CHECKING LATER . . .
	IML_USINT MaxSequenceCnt = 32;
	IML_USINT MaxBlitCnt = 64;
	IML_USINT GroupCount = 8;
	IML_ULINT ExitOnErr = TRUE;
	mvl_video_manager MacVideo(MaxSequenceCnt,MaxBlitCnt, GroupCount, ExitOnErr);
	
	MacVideo.initialize_screen(0);
	MacVideo.set_mvl_calibration(MacVideo.MaxDac, 2, 0, 100);
	MacVideo.set_attenuator_red_steps(0.0);
	MacVideo.use_mvl_calibration();
	MacVideo.linearize_clut(0.5,1.0);

	enum {
		SIMPLE_RANDOTS, 
		MCKEE_WELCH_RANDOTS, 
		MCKEE_WELCH_ST_RANDOTS_FFT
		};

	IML_LINT DemoSelector = MCKEE_WELCH_ST_RANDOTS_FFT;

	switch(DemoSelector) {
	
		
		case MCKEE_WELCH_RANDOTS: {
			// DEFINE IMAGE DIMENSIONS FOR EXAMPLE CODE
			IML_LINT SeqLength = 10;
			IML_LINT  XSize= 128,  YSize= XSize;
			IML_FLOAT SpatialSNR = 0.99;
			IML_LINT DotCount = 100;
			point_2d Delta(-1,1);
	
			mckee_welch_randots(
				MacVideo, XSize, 	YSize, SeqLength, DotCount,	SpatialSNR,
				//delta, 	lifetime		location on screen
				Delta,		2,			point_2d(200,200),
				// use group refresh (TRUE) or fractional (FALSE)
				FALSE );
			}; break;
	
		case MCKEE_WELCH_ST_RANDOTS_FFT: {
			// DEFINE IMAGE DIMENSIONS FOR EXAMPLE CODE
			IML_LINT SeqLength = 100;
			IML_LINT  XSize= 128,  YSize= 128;
			IML_FLOAT SpatialSNR = 1;
			IML_LINT DotCount = 80;
			point_2d Delta(0,0);
			point_2d Position(MacVideo.get_screen_position(2,XSize,YSize,10));
			
IML_SINT Amplitude = true;

			M_and_W_spacetime_randots_fourier(
				MacVideo, XSize, 	YSize, SeqLength, DotCount,	SpatialSNR,
				//delta, 	lifetime		location on screen
				Delta,		8,			point_2d(20+XSize, 10 ),
				// use group refresh (TRUE) or fractional (FALSE)
				TRUE , Amplitude);
		
			get_key_stroke();
			}; break;
		} // end switch
	
	}
	
catch ( ... ) {
// THIS IS JUST TO ALLOW TERMINATION OF THE PROGRAM AND CLEAN UP OF STUFF.
	}

	return(0);
} // end run_experiment


//====================================================================
//
//======================================================================
void mckee_welch_randots(mvl_video_manager & MacVideo,
		IML_LINT  XSize, IML_LINT YSize, IML_LINT SeqLength, 
		IML_USINT DotCount, IML_FLOAT SpatialSNR,
		point_2d IML_REF Delta, IML_USINT LifeTime,
		point_2d IML_REF Position, IML_LINT GroupRefresh) {


	IML_USINT SignalDotCount	= DotCount*SpatialSNR + 0.5;
	IML_USINT NoiseDotCount = DotCount-SignalDotCount;
	// AFTER QUANTIZING TO DOTS
	SpatialSNR = SignalDotCount/(IML_FLOAT)DotCount;
	IML_CLIPIT(LifeTime, 1,LifeTime,YSize);

	IML_USINT RefreshGroupSize;
	if(GroupRefresh) RefreshGroupSize = SignalDotCount;
	else RefreshGroupSize = SignalDotCount/LifeTime; // FRACTIONAL VERSION
	
	IML_USINT DotArraySize = DotCount + RefreshGroupSize;

	fprintf(stderr,"SDC(%d) SNR(%f) RGS(%d) ASize(%d): \n",
		SignalDotCount, SpatialSNR, RefreshGroupSize, DotArraySize);
	
	typedef iml_sequence<point_2d>	iml_dot_sequence;
	iml_dot_sequence Dots(DotArraySize);
	
	mvl_clock Timer;
	
	random_screen_position RefreshGroupNoise( Timer.seed(), Timer.seed()*2);
	if(Delta.X >= 0) {
		RefreshGroupNoise.set_X_min_max(  0, XSize - Delta.X*LifeTime - 1);
	} else {
		RefreshGroupNoise.set_X_min_max( -Delta.X*LifeTime, XSize-1);
		}
				
	if(Delta.Y >= 0) {
		RefreshGroupNoise.set_Y_min_max(  0, YSize - Delta.Y*LifeTime - 1);
	} else {
		RefreshGroupNoise.set_Y_min_max( -Delta.Y*LifeTime, YSize-1);
		}
		
	random_screen_position RandomNoise( Timer.seed()/4, Timer.seed()/8);
	RandomNoise.set_X_min_max(  0, XSize-1);
	RandomNoise.set_Y_min_max(  0, YSize-1);
	
	// SET INITIAL DOT POSITIONS
	for(IML_USINT I=0; I<SignalDotCount+RefreshGroupSize; I++) {
		Dots[I] = RefreshGroupNoise;
		}

	for(IML_USINT I=SignalDotCount+RefreshGroupSize; I<DotArraySize; I++) {
		Dots[I] = RandomNoise;
		}

	// MAKE THE 3D IMAGE SEQUENCE
	iml_ubyte_image DotImage( XSize, YSize ,SeqLength );
	if( !DotImage.valid_memory() ) {
		iml_error("mckee_welch_randots","Could not allocate image!");
		return;
		} // end if

	// WE WILL CREATE THE IMAGE ONE SLICE AT TIME, SO RESTRICT TO 2D SUBSPACE
	DotImage.set_hyperplane_size(2);
	
	// NOW, ONE SLICE AT A TIME . . .
	for(IML_ULINT K=0; K<SeqLength; K++) {

		// SET CURRENT SLICE
		DotImage.select_hyperplane(K);
//		DotImage.select_hyperplane(0);

		DotImage=1; // OUR CLUT'S GO FROM 1 TO 254

		// WRITE SIGNAL DOT POSITIONS TO IMAGE
		for(IML_ULINT I=0; I<SignalDotCount; I++)  {
		int Index = I;
		long X = Dots[Index].X;
		long Y = Dots[Index].Y;
			DotImage(X, Y) = 254;
//			DotImage(Dots[Index].X, Dots[Index].Y) = 254;
			}
		
		// WRITE NOISE DOT POSITIONS TO IMAGE
		IML_ULINT FirstNoiseDot = SignalDotCount;
		if( GroupRefresh && ((K+1)%LifeTime) ) 
			FirstNoiseDot += RefreshGroupSize;	// next frame is not refresh

		for(IML_ULINT I=FirstNoiseDot; I<FirstNoiseDot+NoiseDotCount; I++) {
			DotImage(Dots[I].xi(), Dots[I].yi()) = 254;
			}
		
//		for(long XX=0;XX<XSize;XX++) {
//			for(long YY=0;YY<YSize; YY++) {
//				DotImage(XX,YY) = 127 + 127*cos(2*3.14159*XX/XSize + 3.14159/4);
//				}
//			}
		
	// TEMPORARY FOR CHECKING
	MacVideo.display_image( DotImage, Position );
//	MacVideo.start_timer();
//	while(MacVideo.get_timer() < 0.1) {};

		// ROTATE THE BUFFER (IF NECESSARY)
		if(	!GroupRefresh || // fractional version
				// or group, and group should die next frame
				(GroupRefresh && !((K+1)%LifeTime)) ) {
			Dots.rotate(RefreshGroupSize);
			} // end if

		// UPDATE SIGNAL DOT POSITIONS
		for(IML_ULINT I=0; I<SignalDotCount; I++) 
			Dots[I] += Delta;
			
		// RANDOMIZE SIGNAL-DOT-ASSOCIATED NOISE POSITIONS
		for(IML_ULINT I=SignalDotCount; I<SignalDotCount+RefreshGroupSize; I++)  
			Dots[I] = RefreshGroupNoise;
			
		// RANDOMIZE NOISE DOT POSITIONS
		for(IML_ULINT I=SignalDotCount+RefreshGroupSize; I<DotArraySize; I++)  
			Dots[I] = RandomNoise;
		
		} // end for
	
	// RESET SUBSPACE SIZE TO 3D FOR MAC VIDEO STORAGE
	DotImage.set_hyperplane_size(3);
	IML_USINT ImSeqID = MacVideo.store_image_sequence(DotImage);
	
	iml_imageframe_sequence SinglePassSeq(SeqLength);
	SinglePassSeq.generate_linear_sequence(0,1);
	
	//SinglePassSeq.sin( SeqLength/2.0, SeqLength/2.0-0.00001, SeqLength, 0.0);
	
	iml_imageframe_sequence MultiPassSeq(SeqLength*10);
	MultiPassSeq = SinglePassSeq;
	
	IML_USINT BlitSeqID = MacVideo.create_blit_sequence(ImSeqID, Position, MultiPassSeq);
	MacVideo.play_blit_sequence(BlitSeqID);


} // end mckee_welch_randots


//======================================================================
//
//======================================================================
void M_and_W_spacetime_randots_fourier(mvl_video_manager & MacVideo,
		IML_LINT  XSize, IML_LINT YSize, IML_LINT SeqLength, 
		IML_USINT DotCount, IML_FLOAT SpatialSNR,
		point_2d IML_REF Delta, IML_USINT LifeTime,
		point_2d IML_REF Position, IML_LINT GroupRefresh, long Amplitude) {

	Delta.Y = 0;
	
	IML_CLIPIT(SpatialSNR, 0.0, SpatialSNR, 1.0);

	IML_USINT SignalDotCount	= DotCount*SpatialSNR+0.5;
	IML_USINT NoiseDotCount = DotCount-SignalDotCount;
	// AFTER QUANTIZING TO DOTS
	SpatialSNR = SignalDotCount/(IML_FLOAT)DotCount;
	IML_CLIPIT(LifeTime, 1,LifeTime,YSize);

	IML_USINT RefreshGroupSize;
	if(GroupRefresh) RefreshGroupSize = SignalDotCount;
	else RefreshGroupSize = SignalDotCount/LifeTime; // FRACTIONAL VERSION
	
	IML_USINT DotArraySize = DotCount + RefreshGroupSize;

	fprintf(stderr,"SDC(%d) SNR(%f) RGS(%d) ASize(%d): \n",
		SignalDotCount,SpatialSNR,RefreshGroupSize, DotArraySize);
	
	typedef iml_sequence<point_2d>	iml_dot_sequence;
	iml_dot_sequence Dots(DotArraySize);
	
	
	mvl_clock Timer;
	random_screen_position RefreshGroupNoise( Timer.seed(), Timer.seed()*2);
	if(Delta.X >= 0) {
		RefreshGroupNoise.set_X_min_max(  0, XSize - Delta.X*LifeTime - 1);
	} else {
		RefreshGroupNoise.set_X_min_max( -Delta.X*LifeTime, XSize-1);
		}
				
	RefreshGroupNoise.set_Y_min_max( 0,0);
		
	random_screen_position RandomNoise( Timer.seed()*3, Timer.seed()*4);
	RandomNoise.set_X_min_max(  0, XSize-1);
	RandomNoise.set_Y_min_max(  0, 0);
	
	// SET INITIAL DOT POSITIONS
	for(IML_USINT I=0; I<SignalDotCount+RefreshGroupSize; I++)  
				Dots[I] = RefreshGroupNoise;

	for(IML_USINT I=SignalDotCount+RefreshGroupSize; I<DotArraySize; I++)  
				Dots[I] = RandomNoise;
	
	iml_ubyte_image DotImage(XSize,YSize);
	if( !DotImage.valid_memory() ) {
		iml_error("spacetime_randots_fourier","Could not allocate DotImage image!");
		return;
		} // end if
	iml_fcomplex_image FImage(XSize,YSize);
	if( !FImage.valid_memory() ) {
		iml_error("spacetime_randots_fourier","Could not allocate FImage image!");
		return;
		} // end if
	iml_double_image Averager(XSize,YSize);
	if( !Averager.valid_memory() ) {
		iml_error("spacetime_randots_fourier","Could not allocate Averager image!");
		return;
		} // end if
	iml_fcomplex Zero(0,0);
	iml_fcomplex Marker(0.5,0);
	FImage = Zero;
	Averager = 0.0;
	IML_DOUBLE Divisor = 1;//(SeqLength*iml_sqrt(XSize*(float)YSize));
 
	long K, J, I;
	for( K=0; K<SeqLength; K++) {

		DotImage=1;
		FImage = Zero;
		FImage.non_fourier_domain();
		// generate an image
	
		for( J=0; J<YSize; J++) {
			
			// WRITE SIGNAL DOT POSITIONS TO IMAGE
			for( I=0; I<SignalDotCount; I++) { 
				FImage(Dots[I].xi(), J).Real += 1;
				DotImage(Dots[I].xi(), J) = 254;
				}
			
			// WRITE NOISE DOT POSITIONS TO IMAGE
			IML_USINT FirstNoiseDot = SignalDotCount;
			if( GroupRefresh && ((J+1)%LifeTime) ) 
				FirstNoiseDot += RefreshGroupSize;	// next frame is not refresh

			for( I=FirstNoiseDot; I<FirstNoiseDot+NoiseDotCount; I++) { 
				FImage(Dots[I].xi(), J).Real = 1;
				DotImage(Dots[I].xi(), J) = 254;
				}

			// WRITE CURRENT DOT POSITIONS TO IMAGE
//			for(IML_ULINT I=0; I<DotCount; I++) { 
//				FImage(Dots[I].xi(), J).Real = 1;
//				DotImage(Dots[I].xi(), J) = 254;
//				}
			
			// DISPLAY THE CURRENT IMAGE
//			MacVideo.display_image( DotImage, Position );

			// ROTATE THE BUFFER (IF NECESSARY)
			if(	!GroupRefresh || // fractional version
					// or group, and group should die next frame
					(GroupRefresh && !((J+1)%LifeTime)) ) {
				Dots.rotate(RefreshGroupSize);
				} // end if

			// UPDATE SIGNAL DOT POSITIONS
			for( I=0; I<SignalDotCount; I++) 
				Dots[I] += Delta;
				
			// RANDOMIZE SIGNAL-DOT-ASSOCIATED NOISE POSITIONS
			for( I=SignalDotCount; I<SignalDotCount+RefreshGroupSize; I++)  
				Dots[I] = RefreshGroupNoise;
				
			// RANDOMIZE NOISE DOT POSITIONS
			for( I=SignalDotCount+RefreshGroupSize; I<DotArraySize; I++)  
				Dots[I] = RandomNoise;
			
			} // end for
		
		// DISPLAY THE CURRENT IMAGE
		MacVideo.display_image( DotImage, Position );

		FImage.use_n_in_scaling();
		//FImage.use_n_out_scaling();
		//FImage.use_root_n_scaling();
		FImage.forward_FFT(TRUE);

		// ZERO OUT THE DC-ASSOCIATED COMPONENTS
/***
		iml_index IML_REF Indexer = FImage.get_indexer();
		for(IML_LINT I=Indexer.min(IML_2D_X); I<=Indexer.max(IML_2D_X); I++)
			FImage(I,0) = Zero;
		for(IML_LINT I=Indexer.min(IML_2D_Y); I<=Indexer.max(IML_2D_Y); I++)
			FImage(0,I) = Zero;
***/
		// ADD NEW INFO TO AVERAGER
		if(Amplitude) {
//			for(IML_LINT I=0; I<=Averager.Subspace.ElementCount; I++)
//				Averager[I] += FImage[I].get_amp()/Divisor;
			for(long I=0; I<=Averager.element_count(); I++) {
				double Sign = FImage[I].Real < 0 ? -1 : 1;
				Averager[I] += (FImage[I].get_mag() * Sign)/Divisor;
				} // end for
		} else {
			for(long I=0; I<=Averager.element_count(); I++)
				Averager[I] += FImage[I].get_mag()/Divisor;
				} // end else

		} // end for
	
	
	IML_DOUBLE Min, Max;
	Averager.min_max_element(Min,Max);
	fprintf(stderr,"min -- max: %g -- %g\n",Min,Max);

	// FORCE THE DC VALUES (INCLUDING ALL FLICKER) TO MID-RANGE FOR
	// DISPLAY PURPOSES (MAXIMIZE THE CONTRAST OF THE SINC() LOBES)
	IML_FLOAT AxisValue;
	if(Amplitude) AxisValue = 0;
	else AxisValue = 0.0;
	iml_index IML_REF Indexer = Averager.get_indexer();
	for(IML_LINT I=Indexer.min(IML_2D_X); I<=Indexer.max(IML_2D_X); I++)
		Averager(I,YSize/2) = AxisValue;
	for(IML_LINT I=Indexer.min(IML_2D_Y); I<=Indexer.max(IML_2D_Y); I++)
		Averager(XSize/2,I) = AxisValue;

	Averager.min_max_element(Min,Max);
	fprintf(stderr,"min -- max: %g -- %g\n",Min,Max);

	Averager.scale_elements(10,200);
	Averager.min_max_element(Min,Max);
	fprintf(stderr,"min -- max: %g -- %g\n",Min,Max);
	for(IML_ULINT I=0; I<Averager.element_count(); I++)
			DotImage[I] = Averager[I];

	Position.Y+=YSize+30;
	MacVideo.display_image( DotImage, Position );

{
char Buff[100];
fgets(Buff, 100, stdin);
for(long YY=0;YY<YSize; YY++) {
	float Avg = 0.0;
//	fprintf(stderr,"\n%d ", YY );
	for(long XX=0;XX<XSize;XX++) {
		Avg += Averager[YY*XSize + XX];
		//fprintf(stderr,"%f	",Averager[YY*XSize + XX] );
		}
	Avg *= 1.0/XSize;
	fprintf(stderr,"%d	%f\n", YY, Avg );
	}
	fprintf(stderr,"\n");
}


//	iml_image_file Filer;
//	Filer.create_file("example2.raw");
//	Filer.write_image(&DotImage,IML_RAW_FORMAT);
//	Filer.close_file();

} // end M_and_W_spacetime_randots_fourier


//======================================================================
//
//======================================================================
void simple_randots(mvl_video_manager & MacVideo,
		IML_LINT  XSize, IML_LINT YSize, IML_LINT SeqLength, 
		point_2d IML_REF Delta, IML_USINT LifeTime,
		point_2d IML_REF Position) {

	const IML_USINT DotCount	= 60;
	IML_FLOAT SpatialSNR			= 0.4;
	IML_USINT SignalDotCount	= DotCount*SpatialSNR;
	// AFTER QUANTIZING TO DOTS
	SpatialSNR = SignalDotCount/(IML_FLOAT)DotCount;
	IML_CLIPIT(LifeTime, 1,LifeTime,YSize);

	IML_USINT RefreshGroupSize = SignalDotCount/LifeTime;
		
	typedef iml_sequence<point_2d>	iml_dot_sequence;
	iml_dot_sequence Dots(DotCount);
			
	mvl_clock Timer;
	uniform_rv UniformX;
	UniformX.set_min_max(0.0, XSize-LifeTime*Delta.X - 1e-10);
	UniformX.seed(Timer.seed());
	
	// randomize positions
	for(IML_USINT I=0; I<DotCount; I++)  Dots[I].X = UniformX.sample();

	
	iml_ld_index TwoDSize(XSize,YSize/*,Seqlength*/);
	iml_ubyte_image DotImage(TwoDSize);
	DotImage = 0;
	for(IML_USINT J=0; J<YSize; J++) {
	
		// WRITE CURRENT DOT POSITIONS TO IMAGE LINE
		for(IML_USINT I=0; I<DotCount; I++) DotImage(Dots[I].xi(), J) = 255;
			
		// UPDATE SIGNAL DOT POSITIONS
		for(IML_USINT I=0; I<SignalDotCount; I++) Dots[I] += Delta;
			
		// RANDOMIZE NOISE DOT POSITIONS
		for(IML_USINT I=SignalDotCount; I<DotCount; I++)  Dots[I].X = UniformX.sample();
		
		Dots.rotate(RefreshGroupSize);
		} // end for
	
//	MacVideo.set_max_contrast(1.0);
//	MacVideo.set_mean_luminance(0.5);
	MacVideo.set_display_CLUT(0.5, 1.0);
	MacVideo.display_image( DotImage, Position );


} // end simple_randots
