#ifndef __IML_ARCH_H__
#define __IML_ARCH_H__
/*----------------------------------------------------------------------
	Legal Stuff (tm)

	Copyright(c)1996-98 R.E. Fredericksen <eric@troland.hipl.uci.edu>
		U.C. Irvine, Irvine, CA (USA)
	
	The accompanying software is free; you may use it in your 
	research  and give it away to others, with the following 
	restrictions. Any copy  you give away must include this 
	Legal Stuff(tm) section, unmodified.  Any file that you have 
	changed must include a note at the top of the file giving your 
	name, the date, and a description of the changes. This software
	may not be sold, whether in source or compiled form, without 
	my permission. 	
	
	THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR
	IMPLIED WARRANTY.  IN PARTICULAR, NEITHER THE AUTHOR NOR THE 
	UNIVERSITY OF CALIFORNIA MAKE ANY REPRESENTATION OR WARRANTY OF 
	ANY KIND CONCERNING THE MERCHANTABILITY OF THIS SOFTWARE OR ITS
	FITNESS FOR ANY PARTICULAR PURPOSE.
	
----------------------------------------------------------------------*/

#include "iml_port.h"

// IT TURNS OUT THAT BORLAND CPP 4.0 ONLY DOES 16-BIT ENUM INTEGERS  . . .
//enum {
//	IML_BIG_ENDIAN_BYTE_ORDER = 0x01020408, 
//	IML_LITTLE_ENDIAN_BYTE_ORDER = 0x08040201,
//	IML_UNSPECIFIED_BYTE_ORDER = 0x00000000,
//	IML_BIG_LITTLE_ENDIAN_XFORM = IML_BIG_ENDIAN_BYTE_ORDER | IML_LITTLE_ENDIAN_BYTE_ORDER
//	};


#define	IML_LITTLE_ENDIAN_BYTE_ORDER	(((IML_ULINT)0x08)<<24) | (((IML_ULINT)0x04)<<16) | \
										(((IML_ULINT)0x02)<<8) | (((IML_ULINT)0x01)<<0)
													
#define	IML_BIG_ENDIAN_BYTE_ORDER		(((IML_ULINT)0x01)<<24) | (((IML_ULINT)0x02)<<16) | \
										(((IML_ULINT)0x04)<<8) | (((IML_ULINT)0x08)<<0)
													
#define	IML_UNSPECIFIED_BYTE_ORDER			(0x00000000)
#define	IML_BIG_LITTLE_ENDIAN_XFORM		(IML_BIG_ENDIAN_BYTE_ORDER | IML_LITTLE_ENDIAN_BYTE_ORDER)


inline void iml_4byte_reverse( /*register*/ IML_ULINT & n ) {
   n = ((n >>  8) & 0x00ff00ff) | ((n <<  8) & 0xff00ff00);
   n = ((n >> 16) & 0x0000ffff) | ((n << 16) & 0xffff0000);
  }
  
inline void iml_4byte_reverse( /*register*/ IML_LINT & n ) {
   n = ((n >>  8) & 0x00ff00ff) | ((n <<  8) & 0xff00ff00);
   n = ((n >> 16) & 0x0000ffff) | ((n << 16) & 0xffff0000);
  }
  
//void iml_byte_reverse( register IML_LINT & n )
//	{ iml_byte_reverse((IML_ULINT IML_REF)n); }
	
inline void iml_2byte_reverse( /*register*/ IML_USINT & n ) 
	{ n = ((n >>  8) & 0x00ff) | ((n <<  8) &  0xff00); }
  
inline void iml_2byte_reverse( /*register*/ IML_SINT & n ) 
	{ n = ((n >>  8) & 0x00ff) | ((n <<  8) &  0xff00); }
  
//void iml_byte_reverse( register IML_SINT & n )
//	{ iml_byte_reverse((IML_ULINT &)n); }

//void iml_byte_reverse( register IML_FLOAT & n )
//	{ iml_byte_reverse( *((IML_ULINT *)&n)); }

inline void iml_8byte_reverse( register IML_DOUBLE & n ) { 
	register IML_ULINT * UL = (IML_ULINT IML_PTR)&n;
	iml_4byte_reverse( UL[0] ); 
	iml_4byte_reverse( UL[1] ); 
	IML_ULINT T = UL[0]; UL[0] = UL[1]; UL[1] = T;
	}

/***/
inline void iml_2x4byte_reverse( register IML_FCOMPLEX & n ) { 
	iml_4byte_reverse( (IML_ULINT IML_REF)n.Real ); 
	iml_4byte_reverse( (IML_ULINT IML_REF)n.Imag ); 
	}

inline void iml_2x8byte_reverse( register IML_DCOMPLEX & n ) { 
	iml_8byte_reverse( n.Real ); 
	iml_8byte_reverse( n.Imag ); 
	};
/***/

#if __HAVE_LDOUBLE__
inline void iml_ld_byte_reverse( register IML_LDOUBLE & n ) { 
	//struct shorts {IML_USINT Shorts[5]};
	register IML_USINT * US = (IML_USINT *)&n;
	iml_byte_reverse( US[0] ); 
	iml_byte_reverse( US[1] ); 
	iml_byte_reverse( US[2] ); 
	iml_byte_reverse( US[3] ); 
	iml_byte_reverse( US[4] ); 
	register IML_ULINT T;
	T = US[0]; US[0] = US[4]; US[4] = T;
	T = US[1]; US[1] = US[3]; US[3] = T;
	};

inline void iml_2xld_byte_reverse( register IML_LDCOMPLEX & n ) { 
	iml_ld_byte_reverse( n.Real ); 
	iml_ld_byte_reverse( n.Imag ); 
	};

#endif //if __HAVE_LDOUBLE__

#endif //__IML_ARCH_H__

