
#ifndef __IML_CRC_H__
#define __IML_CRC_H__

class crc_calculator {

		// Table of CRCs of all 8-bit messages. 
		static unsigned long crc_table[256];
   
		// Flag: has the table been computed? Initially false. 
		static int crc_table_computed;
	
		void make_crc_table(void);
   
	public:
		// THIS IS THE ONLY DESTRUCTOR THAT WE NEED
		crc_calculator(void) { 	if (!crc_table_computed) make_crc_table(); };
	
		unsigned long update_crc(unsigned long crc, unsigned char *buf, int len);
		
		// Return the CRC of the bytes buf[0..len-1]. 
		unsigned long crc(unsigned char *buf, int len) 
			{ return(update_crc(0xffffffffL, buf, len) ^ 0xffffffffL); };

}; // end crc_calculator



#endif // __IML_CRC_H__
