#ifndef __IML_FUNC__
#define __IML_FUNC__
/*----------------------------------------------------------------------
	Legal Stuff (tm)

	Copyright(c)1996-98 R.E. Fredericksen <eric@troland.hipl.uci.edu>
		U.C. Irvine, Irvine, CA (USA)
	
	The accompanying software is free; you may use it in your 
	research  and give it away to others, with the following 
	restrictions. Any copy  you give away must include this 
	Legal Stuff(tm) section, unmodified.  Any file that you have 
	changed must include a note at the top of the file giving your 
	name, the date, and a description of the changes. This software
	may not be sold, whether in source or compiled form, without 
	my permission. 	
	
	THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR
	IMPLIED WARRANTY.  IN PARTICULAR, NEITHER THE AUTHOR NOR THE 
	UNIVERSITY OF CALIFORNIA MAKE ANY REPRESENTATION OR WARRANTY OF 
	ANY KIND CONCERNING THE MERCHANTABILITY OF THIS SOFTWARE OR ITS
	FITNESS FOR ANY PARTICULAR PURPOSE.
	
----------------------------------------------------------------------*/

#include <limits.h>
#include <float.h>
#include <stdarg.h>
#include "iml_type.h"
#include "iml_err.h"
#include "iml_indx.h"


// THIS IS AN ABSTRACT BASE CLASS WITH VIRTUAL FUNCTIONS THAT MUST BE REPLACED
// IN ANY DERIVED CLASSES.  THIS WILL MAKE IT VERY SIMPLE TO IMPLEMENT THE OVERLOADED
// BINARY ARITHMETIC OPERATORS LATER.  THAT IS, WE WILL HAVE TO WRITE MANY FEWER
// INSTANCES BECAUSE THE 'ENUMERATION' OF TYPES CAN BE DONE BY ACCESSING THE
// VIRTUAL FUNCTION (MOVE THE LOOKUP INTO THE VIRTUAL FUNCTION TABLE).

class iml_domain {
	protected:			
		iml_index Domain;

	public:

		iml_domain(IML_ULINT DimCnt) : Domain(DimCnt) { };

		// RETURNS THE VALID INDEX RANGE FOR THE IMAGE
		const iml_index IML_REF get_domain(void) {return(Domain);} 

}; // end class





#endif
