#ifndef __IML_TYPE_H__
#define __IML_TYPE_H__
/*----------------------------------------------------------------------
	Legal Stuff (tm)

	Copyright(c)1993-99 R.E. Fredericksen <eric@troland.hipl.uci.edu>
		U.C. Irvine, Irvine, CA (USA)
	
	The accompanying software is free; you may use it in your 
	research  and give it away to others, with the following 
	restrictions. Any copy  you give away must include this 
	Legal Stuff(tm) section, unmodified.  Any file that you have 
	changed must include a note at the top of the file giving your 
	name, the date, and a description of the changes. This software
	may not be sold, whether in source or compiled form, without 
	my permission. 	
	
	THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR
	IMPLIED WARRANTY.  IN PARTICULAR, NEITHER THE AUTHOR NOR THE 
	UNIVERSITY OF CALIFORNIA MAKE ANY REPRESENTATION OR WARRANTY OF 
	ANY KIND CONCERNING THE MERCHANTABILITY OF THIS SOFTWARE OR ITS
	FITNESS FOR ANY PARTICULAR PURPOSE.
	
----------------------------------------------------------------------*/

#pragma warning( disable : 4018 )  

#ifdef _Windows
#define __I_DO_WINDOWS__
#endif

#ifdef __INTEL__
#define __I_DO_WINDOWS__
#endif

#include "iml_port.h"

#ifdef __MSDOS__
#define __HAVE_LDOUBLE__ 1
#else
#define __HAVE_LDOUBLE__ 0
#endif


// THIS IS THE DEFAULT
#define IML_VERBOSE_SAFETY

// MUST SPECIFICALLY REQUEST "NO_SAFTEY"
#ifdef IML_NO_SAFETY
#undef IML_VERBOSE_SAFETY
#endif


#define IML_CLIP_LO_NW(a,b)		((b) < (a) ? (a) : (b))
#define IML_CLIP_HI_NW(a,b)		((b) > (a) ? (a) : (b))
#define IML_CLIPIT_NW(d,a,b,c)	 ((d) = IML_CLIP_LO_NW((a),IML_CLIP_HI_NW((c),(b))))

#ifdef IML_VERBOSE_SAFETY
#define IML_CLIPPING_ON
#define CLIP_WARN iml_error("CLIPIT","VALUE OUT OF RANGE!")
#define IML_CLIP_LO(a,b)		((b) < (a) ? (CLIP_WARN,(a)) : (b))
#define IML_CLIP_HI(a,b)		((b) > (a) ? (CLIP_WARN,(a)) : (b))
#define IML_CLIPIT(d,a,b,c)	 	((d) = IML_CLIP_LO((a),IML_CLIP_HI((c),(b))))
#else
#define IML_CLIPIT(d,a,b,c)	 	((d) = (b))
#endif


#ifdef NO_POLYMORPHISM
#define POLYMORPHIC
#else
#define POLYMORPHIC		virtual
#endif

#define __IML_FNGEN_ALMOST_ZERO__		(1e-20)

#define __IML_FNGEN_MAXPOWER__			(10.0)
#define __IML_FNGEN_MINPOWER__			(1.0/__IML_FNGEN_MAXPOWER__)


// DO THIS SO THAT WE DON'T HAVE THE 
// PROBLEM WHERE UINT_MAX DEPENDS ON INTEGER SIZE
#define MAX_CHUNK_SIZE 		65535U

/// Maximum 32-bit unsigned integer value.
#define IML_ULINT_MAX		4294967295U
/// Maximum 16-bit unsigned integer value.
#define IML_USINT_MAX		65535U
/// Maximum 8-bit unsigned integer value.
#define IML_UBYTE_MAX		255

/// Maximum 32-bit signed integer value.
#define IML_LINT_MAX			2147483647L
/// Minimum 32-bit signed integer value.
#define IML_LINT_MIN			(-2147483648L)

/// Maximum 16-bit signed integer value.
#define IML_SINT_MAX			32767
/// Minimum 16-bit signed integer value.
#define IML_SINT_MIN			(-32768)

/// Maximum 8-bit signed integer value.
#define IML_BYTE_MAX			127
/// Minimum 8-bit signed integer value.
#define IML_BYTE_MIN			(-128)

#if __HAVE_LDOUBLE__
#define IML_LDOUBLE		long double
#else    // DO SOMETHING REASONABLE IN OTHER SYSTEMS
#define IML_LDOUBLE     double
#endif

#define IML_FCOMPLEX		iml_fcomplex
#define IML_DCOMPLEX		iml_dcomplex

#if __HAVE_LDOUBLE__
#define IML_LDCOMPLEX		iml_ldcomplex
#else    // DO SOMETHING REASONABLE IN OTHER SYSTEMS
#define IML_LDCOMPLEX		iml_dcomplex
#endif

#endif // __IML_TYPE_H__
