#ifndef __SCREEN_TILER_H__
#define __SCREEN_TILER_H__

//============================================================================
//
//============================================================================
class screen_tiler {
	public:
		point_2d C;		// origin
		point_2d UL;		// the UL corner of the box to be tiled
		point_2d LR;		// the size of the box to be tiled
		point_2d N;		// there are Nx by Ny positions
		point_2d D;		// spacing for corners
		
		screen_tiler(long CX, long CY)	: UL(0,0), LR(CX,CY)	{};
		screen_tiler(point_2d Size)  		: UL(0,0), LR(Size)	{};
		screen_tiler(point_2d Corner, point_2d Size)  : UL(Corner), LR(Size) {};
			
			// tile count NX by NY
		point_2d tile_screen_with_grid(long NX, long NY,) {
			D.set(LR.X/float(NX), LR.Y/float(NY));
			N.set(NX,NY);
			return(D);
			};
		
		// tile screen given the square size
		point_2d tile_screen_with_square(long DX, long DY ) {
			D.set(DX, DY);
			N.set(long(LR.X/D.X), long(LR.Y/D.Y));
			return(N);
			};
		
		bool point_in_box(point_2d Point) {
			if(	(Point.X > UL.X) && (Point.X < UL.X+LR.X) &&
					(Point.Y > UL.Y) && (Point.Y < UL.Y+LR.Y) 
				) 
				return(true);
			else
				return(false);
			}
					
		point_2d which_tile(point_2d Point) {
			Point -= UL;
			if(Point.X < 0 ) Point.X=0;	
			if(Point.Y < 0 ) Point.Y=0;
			Point.set( long(Point.X/D.X), long(Point.Y/D.Y) );
			if(Point.X >= N.X ) Point.X=N.X-1;	
			if(Point.Y >= N.Y ) Point.Y=N.Y-1;
			return( Point );
			};
		
		point_2d operator()(long XPos, long YPos=0) {
			if(XPos < 0 ) XPos=0;	
			if(YPos < 0 ) YPos=0;
			if(XPos >= N.X ) XPos=N.X-1;	
			if(YPos >= N.Y ) YPos=N.Y-1;
			point_2d Point( long(XPos*D.X), long(YPos*D.Y) ); 
			Point += UL;
			return( Point );
			};
		
};

#endif // __SCREEN_TILER_H__
