#ifndef __VECTOR_3D_H__
#define __VECTOR_3D_H__


class vector_3d {
	private:
		float X, Y, Z;
	public:
		vector_3d(void)	
			{ X=1; Y=Z=0; };
		vector_3d(float x, float y, float z) 
			{ X=x; Y=y; Z=z; };
		vector_3d(vector_3d & P) 
			{ X = P.x(); Y = P.y(); Z = P.z(); };
		void operator=(vector_3d &P) 
			{ X = P.x(); Y = P.y(); Z = P.z(); };
		
		float x(void)	{ return(X); };
		float y(void)	{ return(Y); };
		float z(void)	{ return(Z); };
		
		void x(float x)	{ X=x; };
		void y(float y)	{ Y=y; };
		void z(float z)	{ Z=z; };
		
		void translate(vector_3d & T)	{ X+=T.X; Y+=T.Y; Z+=T.Z; };
		void scale(float F)				{ X*=F; Y*=F; Z*=F; };
		float magnitude(void)			{ return( sqrt(X*X+Y*Y+Z*Z) ); };
		void normalize(void)	{ 
			float M=magnitude();
			if( M == 0.0 ) return;
			X/=M; Y/=M; Z/=M; 
			};
		
		float dot(vector_3d & B)	{ return(B.X*X + B.Y*Y + B.Z*Z); };
		
		vector_3d cross( vector_3d & B) {
			vector_3d C; 
			C.x(Y*B.z() - Z*B.y());
			C.y(Z*B.x() - X*B.z());
			C.z(X*B.y() - Y*B.x());
			return(C);
			};
						
	}; // end class vector_3d


#endif // __VECTOR_3D_H__
