/*----------------------------------------------------------------------
	Legal Stuff (tm)

	Copyright(c)1996-98 R.E. Fredericksen <eric@troland.hipl.uci.edu>
		U.C. Irvine, Irvine, CA (USA)
	
	The accompanying software is free; you may use it in your 
	research  and give it away to others, with the following 
	restrictions. Any copy  you give away must include this 
	Legal Stuff(tm) section, unmodified.  Any file that you have 
	changed must include a note at the top of the file giving your 
	name, the date, and a description of the changes. This software
	may not be sold, whether in source or compiled form, without 
	my permission. 	
	
	THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR
	IMPLIED WARRANTY.  IN PARTICULAR, NEITHER THE AUTHOR NOR THE 
	UNIVERSITY OF CALIFORNIA MAKE ANY REPRESENTATION OR WARRANTY OF 
	ANY KIND CONCERNING THE MERCHANTABILITY OF THIS SOFTWARE OR ITS
	FITNESS FOR ANY PARTICULAR PURPOSE.
	
----------------------------------------------------------------------*/

#include <Timer.h>
#include "mvl_mclk.h"

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%   mvl_clock   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//=====================================================================
//
//=====================================================================
void mvl_clock::start(void) { Microseconds(&ST); }

//=====================================================================
//
//=====================================================================
IML_ULINT mvl_clock::seed(void) { 
	Microseconds(&ClockSeed);
	return(ClockSeed.lo);
}

//=====================================================================
//
//=====================================================================
IML_FLOAT mvl_clock::time(void) {
	Microseconds(&ET);
	// 4294967296.0 IS 2^32 IN DOUBLE FORMAT; *MUST* BE A DOUBLE :)
	return( ((ET.lo-ST.lo) + 4294967296.0*(ET.hi-ST.hi)) / 1e6);
}


//=====================================================================
//
//=====================================================================
void mvl_clock::wait(IML_FLOAT WaitTime) 
	{ for( WaitTime += time(); time() < WaitTime; ) {};  }
