#ifndef __PCI_THUNDER_H__
#define __PCI_THUNDER_H__

/*----------------------------------------------------------------------
	Legal Stuff (tm)

	Copyright(c)1996-98 R.E. Fredericksen <eric@troland.hipl.uci.edu>
		U.C. Irvine, Irvine, CA (USA)
	
	The accompanying software is free; you may use it in your 
	research  and give it away to others, with the following 
	restrictions. Any copy  you give away must include this 
	Legal Stuff(tm) section, unmodified.  Any file that you have 
	changed must include a note at the top of the file giving your 
	name, the date, and a description of the changes. This software
	may not be sold, whether in source or compiled form, without 
	my permission. 	
	
	THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR
	IMPLIED WARRANTY.  IN PARTICULAR, NEITHER THE AUTHOR NOR THE 
	UNIVERSITY OF CALIFORNIA MAKE ANY REPRESENTATION OR WARRANTY OF 
	ANY KIND CONCERNING THE MERCHANTABILITY OF THIS SOFTWARE OR ITS
	FITNESS FOR ANY PARTICULAR PURPOSE.
	
----------------------------------------------------------------------*/


#include <Devices.h>
#include <Quickdraw.h>
#include "iml_type.h"


class pci_thunder_30_1600_card {

	private:
	
		static const IML_ULINT Thunder30VBLStatus;
		static const IML_ULINT Thunder30IndexReg;
		static const IML_ULINT Thunder30DataReg;
		static const IML_ULINT Thunder30VBL_Bit;
	
		IML_ULINT CardBase;
		IML_USINT &ClutIndexReg;
		IML_USINT &ClutDataReg;
	   IML_ULINT &VBLStatusReg;
	
	public:
		pci_thunder_30_1600_card(GDHandle device);
		
		// just need device and table, always loads the whole 256 LUT entries
		OSErr load_dacs(ColorSpec *table, IML_USINT Start=0, IML_USINT End=255);
		
		// just need device and table, always loads the whole 256 LUT entries
		OSErr read_dacs(ColorSpec *table, IML_USINT Start=0, IML_USINT End=255);
		
		// Waits for the beginning of the next vertical blanking interval.
		OSErr wait_for_VBL(void);


}; // end class pci_thunder_30_1600_card

#endif //__PCI_THUNDER_H__
