/* This LuminanceRecord0.h file is a description of a monitor produced by the CalibrateLuminance program. */
/* This file may be #included in any C program. It simply fills in a LuminanceRecord data structure. */
/* Or use ReadLuminanceRecord.c to read this file at runtime. */
/* The theory is described by Pelli & Zhang (1991). The data structure is defined in Luminance.h.  */
/* CalibrateLuminance and Luminance.h are part of the VideoToolbox software. */
/* Pelli & Zhang (1991) Accurate control of contrast on microcomputer displays. */
/* Vision Research, 31:1337-1360. */
/* The VideoToolbox software is available from: */
/* ftp://mirrors.aol.com/pub/info-mac/dev/lib/video-toolbox */
/* Caution: the screen number used here and in GetScreen Device is NOT the same as */
/* displayed by the Monitors cdev in the Control Panel. */
LR.screen=1; /*device=GetScreenDevice(LR.screen);*/
LR.id="Nanao Flexscan 6500";
LR.name="Nanao";
LR.date="12:07 PM Thursday, August 29, 1996";
LR.notes="Pete, Minolta Chromameter CS-100";
LR.dacSize=8;
LR.LMin=2.2599334716796875; /*luminance at VMin*/
LR.LMax=105.012893676757812; /*luminance at VMax*/
LR.LBackground=28.24005126953125; /*background luminance during calibration*/
LR.VBackground=128; /*background number used during calibration*/
LR.dpi=76; /*pixels/inch*/
LR.Hz=75.4830917874396135; /*frames/second*/
LR.units="cd/m^2";
LR.coefficients=9; /*# of coefficients in polynomial fit*/
LR.p[0]=1.71650894446643436e-27;LR.p[1]=9.61260902981162159e-19;\
    LR.p[2]=-9.1083682506214272e-22;LR.p[3]=3.54398412243181096e-23;\
    LR.p[4]=6.20193568052942659e-21;LR.p[5]=1.03824153611022056e-18;\
    LR.p[6]=1.56150391477432259e-16;LR.p[7]=1.77761383629397585e-14;\
    LR.p[8]=-6.4423519405704268e-17;\
     /*L(V)=p[0]+p[1]*V+p[2]*V*V+ . . . polynomialError*/
LR.polynomialError=14.2057211523548207; /*RMS error of fit*/
LR.q[0]=2.82924604415893555;LR.q[1]=-0.00280997762456536293;\
    LR.q[2]=0.00157593528274446726;\
     /*L(V)=q[0]+q[1]*V+q[2]*V*VquadraticError*/
LR.quadraticError=0.517685547003510857; /*RMS error of fit*/
LR.power[0]=1.99265420436859131;LR.power[1]=0.546389460563659668;\
    LR.power[2]=0.0306318793445825577;LR.power[3]=2.18303704261779785;\
     /*L(V)=power[0]+Rectify(power[1]+power[2]*V)^power[3]powerError */\
    /* where Rectify(x)=x if x0, and Rectify(x)=0 otherwise. */\
    /* Pelli & Zhang (1991) Eqs.9&10 use symbols v=V/255, */\
    /* alpha=power[0], beta=power[1], kappa=power[2]*255, gamma=power[3]*/
LR.powerError=0.272199738648888482; /*RMS error of fit*/
LR.fixedPower[0]=1.41937553882598877;LR.fixedPower[1]=0.779797077178955078;\
    LR.fixedPower[2]=0.0269786901772022247;\
    LR.fixedPower[3]=2.27999997138977051;\
     /*L(V)=fixedPower[0]+Rectify(fixedPower[1]+fixedPower[2]*V)^fixedPower[3]fixedPowerError */\
    /* The exponent fixedPower[3] is fixed.*/
LR.fixedPowerError=0.183579972801982089; /*RMS error of fit*/
LR.r=0.0330829245598759832;
LR.g=0.154594416087238208;
LR.b=0.812322659352885808;
LR.gainAccuracy=-0.00334119615647570853;
LR.gm=1.76623674854382571; /*The monitor's contrast gain.*/
LR.rangeSet=0; /*zero indicates that range parameters have yet to be set*/
LR.L.exists=0; /*zero indicates that luminance table has yet to be initialized*/
LR.VMin=0; /*minimum value that can be loaded into DAC*/
LR.VMax=255; /*maximum value that can be loaded into DAC*/


