#include <Events.h>
#include "mvl_mouse.h"

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%   mvl_mouse   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


//============================================================================
bool mvl_mouse::button_down(void) { return( Button() ); };

//============================================================================
bool mvl_mouse::button_still_down(void) { return( StillDown() ); };

//============================================================================
bool mvl_mouse::wait_button_up(void) { return( WaitMouseUp() ); };

//============================================================================
vector_2d mvl_mouse::location(void) {
		GetMouse(&MVLPoint); // JUST GET THE CURRENT MOUSE POSITION INDEPENDENT OF WINDOW
		return( vector_2d(MVLPoint.h,MVLPoint.v) );
};

//============================================================================
void mvl_mouse::flush_all_events(void) { FlushEvents(everyEvent,0); };

//============================================================================
vector_2d mvl_mouse::get_button_down(void) {

	while(  !get_event(mDownMask) ) {
		if( interrupted() ) return(vector_2d(-1,-1));
		};
	return(Position);
	};

//============================================================================
char mvl_mouse::get_key_stroke(void) {

	while( !event_available(keyDownMask | autoKeyMask) ) {
		if( interrupted() ) return(0);
		} // end while
	get_event( keyDownMask | autoKeyMask );
	return(AnyEvent.message&0x000000FF);
	};


//============================================================================
vector_2d mvl_mouse::get_button_up(void) { 
	while(  !get_event(mUpMask) ) {
		if( interrupted() ) return(vector_2d(-1,-1));
		};
	return(Position);
	};

//============================================================================
bool mvl_mouse::get_event(EventMask MVL_EventMask) {
	if( !event_available(MVL_EventMask) ) 
		return(false);
	
	GetNextEvent( MVL_EventMask, &AnyEvent);
	Position.X = AnyEvent.where.h;
	Position.Y = AnyEvent.where.v;

	return(true);
	};


//============================================================================
bool mvl_mouse::event_available(EventMask MVL_EventMask, bool RemoveEvent) {

	if( EventAvail(MVL_EventMask, &Trash) ) {
	
		if(RemoveEvent) trash_event( MVL_EventMask ); // remove the event from the queue
		return(true);
		}
	return(false);
	};

//============================================================================
bool mvl_mouse::interrupted(void) {
	if( event_available( keyDownMask|autoKeyMask ) && 
		IsCmdChar(&AnyEvent,'.') && (AnyEvent.modifiers & cmdKey)) {
			trash_event( keyDownMask|autoKeyMask ); // remove the event from the queue
		return(1);	
		} // end dif
	return(false);
	};

//============================================================================
void mvl_mouse::trash_event(EventMask MVL_EventMask) {	GetNextEvent( MVL_EventMask, &Trash); };


