// MAIN CODE FOR DOS APPLICATION SHELL


#include "iml_dos.h"

#include "string.h"

void mousetest(void) {
dos_mouse Mouse;

	if( !Mouse.mouse_ready()) {
		iml_error("main","mouse is not ready!");
		return;
		} // end if

   button_info Button;
	do {
		Button = Mouse.get_button_press();
		switch(Button.Clicked) {
			case NO_BUTTON: 		iml_message("mousetest","got NO button\n"); break;
			case LEFT_BUTTON:		iml_message("mousetest","got LEFT button\n"); break;
			case RIGHT_BUTTON:	iml_message("mousetest","got RIGHT button\n"); break;
			case MIDDLE_BUTTON:	iml_message("mousetest","got MIDDLE button\n"); break;
			default:					iml_message("mousetest","got STRANGE button\n"); break;
			} // end switch
		//getch();
		} while(Button.Clicked != MIDDLE_BUTTON);
	return;
} // end testmouse



//========================================================================
// DOS MOUSE CONSTRUCTOR;  SAVE THE STATE OF THE MOUSE...
//========================================================================
dos_mouse::dos_mouse(void) {            /* returns status = -1, if okay  */

	 Regs.x.ax = 0;      // MOUSE DRIVER FUNCTION 0
    IML_LINT Status = int86 (0x33, &Regs, &Regs);

	 // SAVE THE MOUSE STATE FOR THE OBJECT USER
	 MouseReady = (Status == -1) ? TRUE : FALSE;

} // end dos_mouse::dos_mouse




//========================================================================
// FOR READING THE POSITION AND BUTTON STATE OF THE MOUSE
//========================================================================
IML_USINT dos_mouse::mouse_state(IML_SINT IML_HREF Horz, IML_SINT IML_HREF Vert) {

	if( !MouseReady ) {
		iml_warning("dos_mouse::mouse_state", "Mouse is not ready!");
		return(NO_BUTTON);
      } // end if

    Regs.x.ax = 3;					// MOUSE DRIVER FUNCTION 3
	 int86 (0x33, &Regs, &Regs);  // ASK THE MOUSE DRIVER FOR INFO

	 IML_USINT BState = Regs.x.bx;	// SETS A BIT IF THE BUTTON IS PRESSED
	 IML_USINT Button;
	 switch(BState & 0x0007) {		// left -> 0x0001, right -> 0x0002, mid -> 0x0004
		case 0x0000: Button = NO_BUTTON; break;
		case 0x0001: Button = LEFT_BUTTON; break;
		case 0x0002: Button = RIGHT_BUTTON; break;
		case 0x0004: Button = MIDDLE_BUTTON; break;
		default:
			iml_error("dos_mouse::mouse_state","Unknown button state!!");
			return(NO_BUTTON);
		} // end switch

	// STORE THE MOUSE POSITIONS IN RETURN VARIBLES
    Horz =  Regs.x.cx;	//  HORIZONTAL POSITION
	 Vert =  Regs.x.dx;	//  VERTICAL POSITION

    return (Button);
} // end mouse_state


//========================================================================
// SPECIFICALLY WAIT FOR A BUTTON PRESS
//========================================================================
button_info dos_mouse::get_button_press(void) {

	if( !MouseReady ) {
		iml_warning("dos_mouse::get_button_press", "Mouse is not ready!");
		return(NO_BUTTON);
      } // end if


	button_info Button; // STORE BUTTON PRESSED
	IML_SINT HPos, VPos; // DUMMY VARIABLES

	// WAIT FOR BUTTON PRESS
	do { Button.Clicked = mouse_state(HPos, VPos); } while(Button.Clicked == NO_BUTTON);

	// WAIT FOR BUTTON RELEASE
   button_info Wait;
	do { Wait.Clicked = mouse_state(HPos,HPos); } while(Wait.Clicked != NO_BUTTON );

   return (Button);
} // end get_button_press


//======================================================================
// MAIN PROGRAM SHELL
//======================================================================
int main(int argc, char *argv[]) {

iml_dosapp_shell IMLDosShell;

// BUILD CMD LINE STRING
int Length = 0;
for(int J=0; J<argc; J++) Length += strlen(argv[J]);

char *CmdLineString = new char[Length+argc+1]; // LEAVE ROOM FOR SPACES, NULL TERMINATOR
char *S = CmdLineString;
for(J=0; J<argc; J++) {
	int SLen = sprintf(S,"%s ",argv[J]);
	S+= SLen;
	} // end for

run_experiment(CmdLineString);

return(0);
} // end main

