	  /********************************************************************
      *                                                                  *
      *   Source File: iml_win.h                                          *
      *   Description: Header file for iml_win application                *
      *   Date:        Thu Jan 06 03:48:21 1994                          *
      *                                                                  *
      ********************************************************************/

#ifndef __IML_WIN_H__
#define __IML_WIN_H__

#include <windows.h>
#include <stdio.h>
#include "iml_app.h"


	// Function prototypes for dialog and subdialog modules
	LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
	BOOL CALLBACK  fnAboutBoxDlgProc(HWND, UINT, WPARAM, LPARAM);

#define __IML__MAXNAME 			100
#define __IML_STARTCHAR__		2
#define __IML_STARTLINE__		1
#define __IML_TABSIZE__			8

// WINDOWS APPLICATION SHELL CLASS
class iml_winapp_shell : public iml_app_shell {
	private:
		static char szAppName[__IML__MAXNAME];
		char *CmdLineString;

	protected:
		friend int PASCAL WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
		friend LRESULT CALLBACK MainWndProc( HWND, UINT, WPARAM, LPARAM);
		friend BOOL CALLBACK fnAboutBoxDlgProc( HWND, UINT, WPARAM, LPARAM);

      // HOLDS FILE HANDLES FOR REDIRECTING OUTPUT TO A FILE
		HFILE hDiskFile;

		// WINDOWS 'HWND' IS A 16 BIT NUMBER
		HWND     	hWndMain;

		HINSTANCE   hInst;
		char 			szInstanceName[__IML__MAXNAME];
		int 			HorzRes;
		int			VertRes;
		int			CharHeight;
      int			CharWidth;
		int			MaxLine;
		int			CurrentLine;
		int			CurrentChar;

		int initialize(HINSTANCE hInstance,
						 		HINSTANCE hPrevInstance,
                   		LPSTR  lpszCmdLine,
								int    nCmdShow);
		int run(void);
		int handle_main_message(HWND hWnd, UINT wMessage, WPARAM wParam, LPARAM lParam);
		int fnAboutBox(HWND);
		int handle_dlg_message(HWND hDlg, UINT wMessage, WPARAM wParam, LPARAM lParam);
		void play_wave(IML_SINT SoundID);
	public:
		iml_winapp_shell(const char *InstanceName);

		button_info get_button_press(void);
		void print(char *String);
		void print(IML_USINT Row, IML_USINT Col, char *String);
      void clear(void);

		void sound(IML_SINT SoundNumber);

		void copy_output_to(const char *FileNAme);
		void end_copy_output(void);

}; // end class


#endif // __IML_WIN_H__